<?php

//
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Clever Age                                        |
// +----------------------------------------------------------------------+
// | Author: Olivier Mansour <omansour@clever-age.com>                    |
// +----------------------------------------------------------------------+
//
// ce fichier est appele par inc-public-global ou independament via la ligne de commande

if (!(defined('FRONT') && FRONT)) {
    chdir (dirname(__FILE__).'/../../');   // pour les include_ecrire
    // TODO : c'est nul :-(
}



require_once (dirname(__FILE__)."/../inc_version.php3");
require_once (dirname(__FILE__)."/../inc_meta.php3");
require_once (dirname(__FILE__)."/../inc_connect.php3");

// ce fichier est initialement appele depuis la racine ...

//
// Archivage des statistiques du site public
//

//
// Envoi du mail quoi de neuf
//
if ($GLOBALS['db_ok']) {
    if ((lire_meta('quoi_de_neuf') == 'oui') AND ($jours_neuf = lire_meta('jours_neuf'))
        AND ($adresse_neuf = lire_meta('adresse_neuf')) AND (time() - ($majnouv = lire_meta('majnouv'))) > 3600 * 24 * $jours_neuf) {

        if (timeout('quoide_neuf')) {
            include_once (dirname(__FILE__).'/../inc_meta.php3');
            ecrire_meta('majnouv', time());
            ecrire_metas();

            // preparation mail
            unset ($mail_nouveautes);
            unset ($sujet_nouveautes);
            $fond = 'nouveautes';
            $delais = 0;
            $contexte_inclus = array('date' => date('Y-m-d H:i:s', $majnouv));
            include(inclure_fichier($fond, $delais, $contexte_inclus));

            // envoi
            if ($mail_nouveautes) {
                spip_log("envoi mail nouveautes");
                include_once(dirname(__FILE__).'/../inc_mail.php3');
                envoyer_mail($adresse_neuf, $sujet_nouveautes, $mail_nouveautes);
            } else
                spip_log("envoi mail nouveautes : pas de nouveautes");
        }
    }
}

// Mise a jour des fichiers langues de l'espace public
if ($cache_lang_modifs) {
    //include_ecrire('inc_lang.php3');
    include_once (dirname(__FILE__).'/../inc_lang.php3');
    ecrire_caches_langues();
}

// Selection d'une rubrique au hasard pour mise a jour
if ($GLOBALS['db_ok']) {
    if ((time() - lire_meta('calcul_rubriques') > 3600) AND timeout('calcul_rubriques')) {
        require_once (dirname(__FILE__).'/../include/bd/inc_rubrique_factory.php');

        // Chargement d'une rubrique au hasard
        $rub =& recuperer_instance_rubrique();
        $rub_ids = $rub->getAllRubriqueId();
        $id = $rub_ids[ array_rand($rub_ids) ];
        $status = $rub->load( $id );
        if ( PEAR::isError($status) ) {
            // die($status->getMessage());
            PEAR::raiseError("Rubrique::Load $id error ".$status->getMessage(), PEAR_LOG_ERR); 
        } else {
            if ( $rub->checkForPostDated() ) { // va modifier mon objet rubrique
                $update = $rub->update();
                if ( PEAR::isError($update) ) { 
                    //die($status->getMessage());
                    PEAR::raiseError("Rubrique::update $id error ".$update->getMessage(), PEAR_LOG_ERR); 
                }
            }
            if ( $rub->checkForExpired() ) { // va modifier mon objet rubrique
                $update = $rub->update();
                if ( PEAR::isError($update) ) { 
                    // die($status->getMessage());
                    PEAR::raiseError("Rubrique::update $id error".$update->getMessage(), PEAR_LOG_ERR); 
                }
            }
            
        }
        // Mise a our de la derniere date de mise a jour des rubriques
        require_once dirname( __FILE__ ) . '/../inc_meta.php3';
        ecrire_meta('calcul_rubriques', time());
        ecrire_metas();
    }
}


if ($GLOBALS['db_ok']) {
	if (lire_meta("activer_statistiques") != "non") {
		if (timeout(false, false))  // no lock, no action
		{
			// Conditions declenchant un eventuel calcul des stats
			if ((lire_meta('calculer_referers_now') == 'oui')
			OR (date("Y-m-d") <> lire_meta("date_statistiques"))
			OR (time() - lire_meta('date_stats_popularite') > 1800)) {
				include_once (dirname(__FILE__).'/../../inc-stats.php3');
				archiver_stats();
			}
		}
	}
}


//
// Faire du menage dans le cache (effacer les fichiers tres anciens ou inutilises)
// Se declenche une fois par heure quand le cache n'est pas recalcule
//
include (dirname (__FILE__).'/../include/cacheHTML/inc_config_cacheHTML.php');
$cacheDir = $containerParams['cacheHTML_directory'];
if ($use_cache AND file_exists($cacheDir.'.purge2')) {
    if (timeout('purge_cache')) {
    //if (true) {
        unlink($cacheDir.'.purge2');
        spip_log("purge cache niveau 2");
        //----------Modification Clever Age elebescond@clever-age.com omansour---------
        if ($GLOBALS['db_ok']) {
            require_once (dirname(__FILE__)."/../include/bd/inc_forum_factory.php");
            $forumMetier = &recuperer_instance_forum();
            $deleteExpiredCacheOK = $forumMetier->deleteExpiredCache();
            if(PEAR::isError($deleteExpiredCacheOK)) {
                die("->".$deleteExpiredCacheOK->getMessage());
            }
        }
        /*
        $query = "SELECT fichier FROM spip_forum_cache WHERE maj < DATE_SUB(NOW(), INTERVAL 14 DAY)";
        $result = spip_query($query);
        unset($fichiers);
        while ($row = spip_fetch_array($result)) {
            $fichier = $row['fichier'];
            if (!file_exists("CACHE/$fichier")) $fichiers[] = "'$fichier'";
        }
        if ($fichiers) {
            $query = "DELETE FROM spip_forum_cache WHERE fichier IN (".join(',', $fichiers).")";
            spip_query($query);
        }
        */
        //----------Fin Clever Age elebescond@clever-age.com------------------
    }
}

if ($use_cache AND file_exists('CACHE/.purge')) {
    if (timeout('purge_cache')) {
        $dir = 'CACHE/'.dechex((time() / 3600) & 0xF);
        unlink('CACHE/.purge');
        spip_log("purge cache niveau 1: $dir");
        $f = fopen('CACHE/.purge2', 'w');
        fclose($f);
        include_once (dirname(__FILE__).'/../../inc-cache.php3');
        purger_repertoire($dir, 14 * 24 * 3600);
    }
}


//
// Gerer l'indexation automatique
//
if ($GLOBALS['db_ok']) {
    if (lire_meta('activer_moteur') == 'oui') {
    	$elementList = array('id_article','id_auteur','id_breve','id_mot','id_rubrique');
    	while (list(,$val) = each($elementList)) {
    		if ($$val == "-1") {
    			$$val = false;
    		}
    	}
        include_once(dirname(__FILE__).'/../inc_index.php3');
        alimenter_fichier_index ($GLOBALS['db_ok']);
        $fichier_index = 'ecrire/data/.index';
        /*
        if ($db_ok AND ($id_article OR $id_auteur OR $id_breve OR $id_mot OR $id_rubrique)) {
            include_ecrire("inc_index.php3");
            $s = '';
            if ($id_article AND !deja_indexe('article', $id_article))
                $s .= "article $id_article\n";
            if ($id_auteur AND !deja_indexe('auteur', $id_auteur))
                $s .= "auteur $id_auteur\n";
            if ($id_breve AND !deja_indexe('breve', $id_breve))
                $s .= "breve $id_breve\n";
            if ($id_mot AND !deja_indexe('mot', $id_mot))
                $s .= "mot $id_mot\n";
            if ($id_rubrique AND !deja_indexe('rubrique', $id_rubrique))
                $s .= "rubrique $id_rubrique\n";
            if ($s != '') {
                if ($f = @fopen($fichier_index, 'a')) {
                    fwrite($f, $s);
                    fclose($f);
                }
            }
        }
        */
        if (defined("FRONT")) {
            if ($use_cache AND file_exists($fichier_index)) {
                $go_indexation = true;
            } else {
                $go_indexation = false;
            }
        } else { // on est en cron
            $go_indexation = true;
        }

        if ($go_indexation) {
            if ($GLOBALS['db_ok']) {
                include_once(dirname(__FILE__).'/../inc_index.php3');
                effectuer_une_indexation();
            }
        }
            /*
            if (timeout('indexation')) {
                include_ecrire("inc_index.php3");
                effectuer_une_indexation();
            }
            */
            /********* Fin modification elebescond@clever-age.com **********/
    }
}

//
// Mise a jour d'un (ou de zero) site syndique
//
if ($GLOBALS['db_ok']) {
    if ($db_ok AND lire_meta("activer_syndic") == "oui") {
        if (timeout()) {
            include_once (dirname(__FILE__)."/../inc_sites.php3");
            executer_une_syndication();
            if (lire_meta('activer_moteur') == 'oui') {
                include_once (dirname(__FILE__)."/../inc_index.php3");
                executer_une_indexation_syndic();
            }
        }
    }
}


//
// Ce code la n'est necessaire que sur les serveurs
// qui ne relachent pas le lock a la fin de script php.
// Ce bout de n'importe quoi s'occupe d'une telle abberation
// Il peut etre supprime si votre serveur n'a pas de probleme.
require_once (dirname(__FILE__).'/../include/bd/inc_service_factory.php');
$serviceMetier = &recuperer_instance_service();
$serviceMetier->getLock('XXXX_INEXISTENT_XXXX');
$serviceMetier->releaseLock('XXXX_INEXISTENT_XXXX');


?>