<?php


////////////////////////////////////////////////////////////////////////////////////
// Pour utiliser les champs "extra", il faut installer dans le fichier
// ecrire/mes_options.php3 un tableau definissant les champs en question,
// pour chaque type d'objet (article, rubrique, breve, auteur ou mot) que
// l'on veut ainsi etendre ; utiliser dans l'espace public avec
// [(#EXTRA|extra{"nom_du_champ"})]


/*

//
// Definition de tous les extras possibles
//

$GLOBALS['champs_extra'] = Array (
	'auteurs' => Array (
			"sexe" => "ligne|brut",
			"age" => "ligne|propre|&Acirc;ge du capitaine",
			"biblio" => "bloc|propre|Bibliographie"
		),

	'articles' => Array (
			"prix" => "ligne|typo|PRIX",
			"isbn" => "ligne|typo|ISBN"
		)
	);
*/


/*

// On peut optionnellement vouloir affiner les extras :
// - pour les articles/rubriques/breves en fonction du secteur ou de la rubrique ;
// L'hritage des champs EXTRA n'est possible qu' partir d'une dfinition par secteur. Il est par contre possible de redfinir pour une rubrique donnee des extras particulier. Dans ce cas cette rubrique n'herite plus des extras definis par le secteur
// - pour les auteurs en fonction du statut
// - pour les mots-cles en fonction du groupe de mots

$GLOBALS['champs_extra_proposes'] = Array (
	'auteurs' => Array (
		// tous : par defaut
		'tous' =>  'age|sexe',
		// une biblio pour les admin (statut='0minirezo')
		'0minirezo' => 'age|sexe|biblio'
		),

	'articles' => Array (
		// tous : par defaut
		'tous' => '',
		// 1 : id_secteur=1;
		1 => 'prix',
		// 4 : id_rubrique=4;
		4 => 'isbn',
		// -5 : id_rubrique-5;
		'-5' => 'isbn|prix'
		)
	);

*/

////////////////////////////////////////////////////////////////////////////////////

//
// Ce fichier ne sera execute qu'une fois
if (defined("_ECRIRE_INC_EXTRA")) return;
define("_ECRIRE_INC_EXTRA", "1");

// a partir de la liste des champs, generer la liste des input
function extra_saisie($extra, $type, $ensemble='') {
	$extra = unserialize($extra);

	// quels sont les extras de ce type d'objet
	if (!$champs = $GLOBALS['champs_extra'][$type])
		$champs = Array();

	// prendre en compte, eventuellement, les champs presents dans la base
	// mais oublies dans mes_options.
	if (is_array($extra))
		while (list($key,) = each($extra))
			if (!$champs[$key])
				$champs[$key] = "masque||($key?)";

	
	// quels sont les extras proposes...
	// ... si l'ensemble est connu
	/************* Modification elebescond@clever-age.com ****************/
	if ($type != 'auteurs' && $type != 'mots') {
		$rubriqueMetier = &recuperer_instance_rubrique();
		$loadOK = $rubriqueMetier->load($ensemble);
		if (!PEAR::isError($loadOK)) {
			$id_secteur = $rubriqueMetier->getSecteurId();
		}
	}
	
	$heritage = false;
	if ($type != 'mots' && $type != 'auteurs') {
		$id_rubrique = $ensemble;
		$rubriqueMetier = &recuperer_instance_rubrique();
		while ($id_rubrique > 0 ) {
			$loadOK = $rubriqueMetier->load($id_rubrique);
			$id_rubrique = $rubriqueMetier->getParentId();
			if (!PEAR::isError($loadOK)) {
				if (isset($GLOBALS['champs_extra_proposes'][$type]['-' . $id_rubrique])) {
					$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type]['-' . $id_rubrique]);
					$id_rubrique = 0;
					$heritage = true;
				}
			}
		}
	}

	//1er cas les Extras sont dfinis pour la rubrique courante.
	if ($ensemble && isset($GLOBALS['champs_extra_proposes'][$type][$ensemble]))
		$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type][$ensemble]);
	//Parcours de la hierarchie  la recherche d'hritage d'EXTRA (-xx)
	else if ($heritage) {
	}
	//2eme cas les Extras sont dfinis pour le secteur courant.
	else if (isset($GLOBALS['champs_extra_proposes'][$type][$id_secteur]) && $type != 'mots' && $type != 'auteurs') {
		$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type][$id_secteur]);
	}
	// ... sinon, les champs proposes par defaut
	else if (isset($GLOBALS['champs_extra_proposes'][$type]['tous'])) {
		$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type]['tous']);
	}	
	// sinon tous les champs extra du type
	else {
		$champs_proposes =  Array();
		reset($champs);
		while (list($ch, ) = each($champs)) $champs_proposes[] = $ch;
	}	
	/*
	if ($ensemble && isset($GLOBALS['champs_extra_proposes'][$type][$ensemble]))
		$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type][$ensemble]);
	// ... sinon, les champs proposes par defaut
	else if (isset($GLOBALS['champs_extra_proposes'][$type]['tous'])) {
		$champs_proposes = explode('|', $GLOBALS['champs_extra_proposes'][$type]['tous']);
	}

	// sinon tous les champs extra du type
	else {
		$champs_proposes =  Array();
		reset($champs);
		while (list($ch, ) = each($champs)) $champs_proposes[] = $ch;
	}
	*/
	/************* Fin modification elebescond@clever-age.com ****************/
	// bug explode
	if($champs_proposes == explode('|', '')) $champs_proposes = Array();

	// maintenant, on affiche les formulaires pour les champs renseignes dans $extra
	// et pour les champs proposes
	reset($champs_proposes);
	while (list(, $champ) = each($champs_proposes)) {
		$desc = $champs[$champ];
		list($form, $filtre, $prettyname) = explode("|", $desc);

		if (!$prettyname) $prettyname = ucfirst($champ);
		$affiche .= "<b>$prettyname&nbsp;:</b><br />";
		switch($form) {
			case "bloc":
			case "block":
				$affiche .= "<textarea name='suppl_$champ' class='forml' rows='10' cols='40'>".entites_html($extra[$champ])."</textarea>\n";
				break;
			case "masque":
				$affiche .= "<font color='#555555'>".interdire_scripts($extra[$champ])."</font>\n";
				break;
			case "ligne":
			case "line":
			default:
				$affiche .= "<input type='text' name='suppl_$champ' class='forml'\n";
				$affiche .= " value=\"".entites_html($extra[$champ])."\" size='40' />\n";
				break;
		}

		$affiche .= "<p>\n";
	}

	if ($affiche) {
		debut_cadre_enfonce();
		echo $affiche;
		fin_cadre_enfonce();
	}
}

// recupere les valeurs postees pour reconstituer l'extra
function extra_recup_saisie($type) {
	$champs = $GLOBALS['champs_extra'][$type];
	if (is_array($champs)) {
		$extra = Array();
		while(list($champ,)=each($champs))
			$extra[$champ]=$GLOBALS["suppl_$champ"];
		return serialize($extra);
	} else
		return '';
}

// Retourne la liste des filtres a appliquer pour un champ extra particulier
function extra_filtres($type, $nom_champ) {
	$champ = $GLOBALS['champs_extra'][$type][$nom_champ];
	if (!$champ) return array();;
	list(, $filtre, ) = explode("|", $champ);
	if ($filtre && $filtre != 'brut' && function_exists($filtre))
		return array($filtre);
	return array();
}

function extra_champ_valide($type, $nom_champ) {
	return isset($GLOBALS['champs_extra'][$type][$nom_champ]);
}

// a partir de la liste des champs, generer l'affichage
function extra_affichage($extra, $type) {
	$extra = unserialize ($extra);
	if (!is_array($extra)) return;
	$champs = $GLOBALS['champs_extra'][$type];

	while (list($nom,$contenu) = each($extra)) {
		list($type, $filtre, $prettyname) = explode("|", $champs[$nom]);
		if ($filtre != 'brut' AND function_exists($filtre))
			$contenu = $filtre($contenu);
		if (!$prettyname)
			$prettyname = ucfirst($nom);
		if ($contenu)
			$affiche .= "<div><strong>$prettyname&nbsp;:</strong> ".interdire_scripts($contenu)."<br /></div>\n";
	}

	if ($affiche) {
		debut_cadre_enfonce();
		echo $affiche;
		fin_cadre_enfonce();
	}
}

?>
