<?php
//
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Clever Age                                        |
// +----------------------------------------------------------------------+
// | Author:Franois Xavier LACROIX <fxlacroix@clever-age.com>                 |
// +----------------------------------------------------------------------+
//
// Base class for Action "afficherOngletAuteur ".
//

// $Id$

require_once (dirname(__FILE__)."/../Action.php");
require_once (dirname(__FILE__)."/../../bd/inc_profil_factory.php");
require_once (dirname(__FILE__)."/../../bd/inc_auteur_factory.php");
require_once (dirname(__FILE__)."/../../bd/inc_rubrique_factory.php");

/**
 * afficherOngletAuteur is an implementation for Common of "afficherOngletAuteur Action.
 * @package	authorization/common
 * @author 	Franois Xavier LACROIX <fxlacroix@clever-age.com>
 * @access	public
 */
class afficherOngletAuteur_common extends Action {
    
        // {{{ _isAuthorized()

    /**
     * Get if a user is authorized to access to a command
     * @access private
     * @return bool
     */

    function _isAuthorized() {

		/*
        $profilMetier = &recuperer_instance_profil();
		$monProfil = $profilMetier->getProfilForIntitule('item_redacteur');
		if(PEAR::isError($monProfil)) {
		    die($monProfil->getMessage());
		}
        */
		// return ($this->_user->getProfil() >= $monProfil->getPoids() OR $this->_user->getAuteurId() == $this->_parameters['id_auteur']);
        
        // If I am an admin with full access to rubriques I can do anything
        $profilMetier = &recuperer_instance_profil();
        $monProfil = $profilMetier->getProfilForIntitule('item_administrateur');
        $rubriqueMetier = recuperer_instance_rubrique();
        if (($this->_user->getProfil() == $monProfil->getPoids()) and (count($rubriqueMetier->getRubriqueManagementForAuteurId($this->_user->getAuteurId())) == 0 )) { 
            return true;
        } 
        
        
        if ($this->_parameters['id_auteur'] == $this->_user->getAuteurId() ) return true; // i can see my own profile
        
        $auteurMetier = &recuperer_instance_auteur();
        $loadOK = $auteurMetier->load ($this->_parameters['id_auteur']);
        if(PEAR::isError($loadOK)) {
            return false; 
        }
        if ($this->_user->getProfil() > $auteurMetier->getProfil()) return true; // I can see profile of auteur "under me"
        
        return false;
        

	}


    // }}} 
    
    
}

?>