<?php
//
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Clever Age                                        |
// +----------------------------------------------------------------------+
// | Author: Erwan LE BESCOND <elebescond@clever-age.com>                 |
// +----------------------------------------------------------------------+
//
// Base class for Action "isManagedRubriqueByAuteurId".
//

if (defined("_AUTHORIZATION_IS_MANAGED_RUBRIQUE_BY_AUTEUR_ID_COMMON")) return;
define("_AUTHORIZATION_IS_MANAGED_RUBRIQUE_BY_AUTEUR_ID_COMMON", "1");

require_once dirname(__FILE__)."/../Action.php";
require_once (dirname(__FILE__)."/../../bd/inc_rubrique_factory.php");

/**
 * isManagedRubriqueByAuteurId is an implementation for Common of "isManagedRubriqueByAuteurId" Action.
 * @package	authorization/common
 * @author 	Erwan Le Bescond <elebescond@clever-age.com>
 * @access	public
 */
class isManagedRubriqueByAuteurId_common extends Action {

    // {{{ _isAuthorized()

    /**
     * Get if a user is authorized to access to a command
     * @access private
     * @return bool
     */

    function _isAuthorized() {
		
		if ($this->_parameters['rubriqueId'] == null) 
			return true;
		$idRubrique = $this->_parameters['rubriqueId'];

		
        /* 
        // factoris dans cacheAllowsRubrique
        */
        /*
		//XXX Pourquoi ca:
		if( !isset($_SESSION['AgoraRubriquesCache']) )
			return true;
		*/
        /*
		if (isset($_SESSION['AgoraRubriquesCache'][$idRubrique])) {
			//ok, we know the answer
			return ($_SESSION['AgoraRubriquesCache'][$idRubrique] != 0);
		}
		else {
			//we don't know the answer 'cause the cache
			//is apparently no longer up-to-date
		    $rubriqueMetier = &recuperer_instance_rubrique();
			return ($rubriqueMetier->updateAgoraCacheForId($this->_user->getAuteurId(), $idRubrique));
		}
        */
        
		return $this->cacheAllowsRubrique($this->_parameters['rubriqueId']);
		
    }

    // }}}
    
}

?>