<?php
//
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Clever Age                                        |
// +----------------------------------------------------------------------+
// | Author:Franois Xavier LACROIX <fxlacroix@clever-age.com>            |
// +----------------------------------------------------------------------+
//
// Base class for Action "modifierSite.
//

if (defined("_AUTHORIZATION_MODIFIER_SITE_COMMON")) return;
define("_AUTHORIZATION_MODIFIER_SITE_COMMON", "1");

require_once dirname(__FILE__)."/../Action.php";
require_once (dirname(__FILE__)."/../../bd/inc_syndic_factory.php");
require_once (dirname(__FILE__)."/../../bd/inc_profil_factory.php");

/**
 * modifierSite is an implementation for Common of "modifierSite" Action.
 * @package	authorization/common
 * @author 	Franois Xavier LACROIX <fxlacroix@clever-age.com>
 * @access	public
 */
class modifierSite_common extends Action {

    // {{{ _isAuthorized()

    /**
     * Get if a user is authorized to access to a command
     * @access private
     * @return bool
     */

    function _isAuthorized() {

        $syndicMetier = &recuperer_instance_syndic();
        $loadOK = $syndicMetier->load($this->_parameters['id_syndic']);
        if(PEAR::isError($loadOK)) {
            echo $loadOK->getMessage();
            return false;
        }

        $profilMetier = &recuperer_instance_profil();
        $monProfil = $profilMetier->getProfilForIntitule('item_redacteur');
        if(PEAR::isError($monProfil)) {
            die($monProfil->getMessage());
        }
        
        if($this->_user->getProfil() == $monProfil->getPoids() AND $syndicMetier->getStatut() != 'prop') return false;

        $monProfil = $profilMetier->getProfilForIntitule('item_redacteur_en_chef');
        if(PEAR::isError($monProfil)) {
            die($monProfil->getMessage());
        }
        if($this->_user->getProfil() == $monProfil->getPoids() AND $syndicMetier->getStatut() != 'prop' AND $syndicMetier->getStatut() != 'publie' AND $syndicMetier->getStatut() != 'refuse') return false;

        $rubriqueMetier = &recuperer_instance_rubrique();
        // return $rubriqueMetier->isManagedByAuteurId($syndicMetier->getRubriqueId(), $this->_user->getAuteurId());
        return $this->cacheAllowsRubrique($syndicMetier->getRubriqueId());
    }
    
    // }}}
    
}

?>