<?php
//
// +----------------------------------------------------------------------+
// | Copyright (c) 2004 Clever Age                                        |
// +----------------------------------------------------------------------+
// | Author:Franois Xavier LACROIX <fxlacroix@clever-age.com>                 |
// +----------------------------------------------------------------------+
//
// Base class for Action "modifierStatutArticle".
// $Id$ 

if (defined("_AUTHORIZATION_MODIFIER_STATUT_ARTICLE_COMMON")) return;
define("_AUTHORIZATION_MODIFIER_STATUT_ARTICLE_COMMON", "1");

require_once dirname(__FILE__)."/../Action.php";
require_once (dirname(__FILE__)."/../../bd/inc_article_factory.php");
/**
 * modifierStatutArticle is an implementation for Common of "modifierStatutArticle" Action.
 * @package	authorization/common
 * @author 	Franois Xavier LACROIX <fxlacroix@clever-age.com>
 * @access	public
 */
 
class modifierStatutArticle_common extends Action {
    
	// {{{ _isAuthorized()

    /**
     * Get if a user is authorized to access to a command
     * @access private
     * @return bool
     */

    function _isAuthorized() {
    
    //return true;

   
        // on verifie d'abord que l'on a acces a l'article
        $authorization = & recuperer_instance_authorization('modifierArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
        if (!$authorization->isAuthorizedAction()) { return false; }
   

   
        $articleMetier = &recuperer_instance_article();
        $loadOK = $articleMetier->load($this->_parameters['id_article']);
        if(PEAR::isError($loadOK)) {
            //echo $loadOK->getMessage();
            return false;
        }
	/*
        $profilMetier = &recuperer_instance_profil();
        $monProfil = $profilMetier->getProfilForIntitule('item_redacteur');
        if(PEAR::isError($monProfil)) {
            die($monProfil->getMessage());
        }
        if($this->_user->getProfil() == $monProfil->getPoids()) {
            if($this->_parameters['statut_nouv'] == 'archi' OR $this->_parameters['statut_nouv'] == 'publie' OR $this->_parameters['statut_nouv'] == 'refuse' OR $this->_parameters['statut_nouv'] == 'poubelle' OR $this->_parameters['statut_nouv'] == 'valid') return false;
            if($articleMetier->getStatut() == 'archi' OR $articleMetier->getStatut() == 'publie' OR $articleMetier->getStatut() == 'refuse' OR $articleMetier->getStatut() == 'poubelle' OR $articleMetier->getStatut() == 'valid' OR  $articleMetier->isAuthor($this->_user->getAuteurId()) == false) return false;
        }

        $monProfil = $profilMetier->getProfilForIntitule('item_redacteur_en_chef');
        if(PEAR::isError($monProfil)) {
            die($monProfil->getMessage());
        }
        if($this->_user->getProfil() == $monProfil->getPoids()) {
            if($this->_parameters['statut_nouv'] == 'archi' OR $this->_parameters['statut_nouv'] == 'publie' OR $this->_parameters['statut_nouv'] == 'poubelle') return false;
            if($articleMetier->getStatut() == 'archi' OR $articleMetier->getStatut() == 'publie' OR $articleMetier->getStatut() == 'poubelle') return false;
        }
        */

//var_dump ($this->_parameters['statut_nouv']);

	if ($this->_parameters['statut_nouv']!=null)
	{
		switch ($this->_parameters['statut_nouv'])
		{
			case 'prepa':
				$authorization = & recuperer_instance_authorization('proposerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'prop':
				$authorization = & recuperer_instance_authorization('proposerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'valid':
				$authorization = & recuperer_instance_authorization('validerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'publie':
				$authorization = & recuperer_instance_authorization('publierArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'archi':
				$authorization = & recuperer_instance_authorization('archiverArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'poubelle':
				$authorization = & recuperer_instance_authorization('jeterArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'refuse':
				$authorization = & recuperer_instance_authorization('refuserArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
		}
		return false;
	}
	else
	{
		switch ($articleMetier->getStatut())
		{
			case 'prepa':
				$authorization = & recuperer_instance_authorization('proposerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'prop':
				$authorization = & recuperer_instance_authorization('proposerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'valid':
				$authorization = & recuperer_instance_authorization('validerArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'publie':
				$authorization = & recuperer_instance_authorization('publierArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'archi':
				$authorization = & recuperer_instance_authorization('archiverArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'poubelle':
				$authorization = & recuperer_instance_authorization('jeterArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
			case 'refuse':
				$authorization = & recuperer_instance_authorization('refuserArticle', $this->_user->getAuteurId(), array ('id_article' => $this->_parameters['id_article']));
				return $authorization->isAuthorizedAction();
				break;
		}
		return false;	
	}
	return false;
    }
    // }}} 
    
}

?>
