<?php

require_once dirname(__FILE__)."/Filter.php";

class FunctionPersonnalisationFilter extends Filter {

    function queryFilter($query) {
        $queryFrom = array();
        $queryWhere = array();
        $cpt = 0;
        if($this->_params['id_auteur'] != "") {
	        $groupeMotMetier = &recuperer_instance_groupe_mot();
	        $allGroupes = $groupeMotMetier->getAllGroupeAffectedToPersonnalisation($this->_params['type'], $this->_params['groupeIds']);
	        if (sizeOf($allGroupes) == 0 ) {
            	$queryFrom[] = $this->_params['table_relation'].'1';
            	$queryWhere[] = 'rel_' . $this->_params['type'] . '1.id_mot IN (-1)';
	        }
	        while (list(, $myGroup) = each($allGroupes)) {
				$cpt++;
				$queryFrom[] = $this->_params['table_relation'].$cpt;
				$motMetier = &recuperer_instance_mot();
				$motAffecte = $motMetier->getAllFromMotsAndAnotherTableForGroupId('auteurs', 'id_auteur', $this->_params['id_auteur'], $myGroup->getGroupeId());
				$motAffecteIds = array();
				while (list(, $monMot) = each($motAffecte)) {
					$motAffecteIds = array_merge ($motAffecteIds, $motMetier->getSubBranchIds($monMot->getMotId()));
				}
				$motAffecteIds = array_unique($motAffecteIds);
				if (sizeOf($motAffecteIds) == 0) {
					$motAffecteIds[] = -1;
				}
	        	$queryWhereTmp = '(rel_' . $this->_params['type'] . $cpt . '.id_mot=' . join(' OR rel_' . $this->_params['type']  . $cpt . '.id_mot=', $motAffecteIds) . ')';
	        	
	        	switch ($this->_params['type']) {
	        		case 'articles':
	        			$queryWhereTmp .=   ' AND (rel_' . $this->_params['type'] . $cpt . '.id_article=articles.id_article)';
	        			break;
	        		case 'breves':
	        			$queryWhereTmp .=   ' AND (rel_' . $this->_params['type'] . $cpt . '.id_breve=breves.id_breve)';
	        			break;
	        		case 'rubriques':
	        			$queryWhereTmp .=   ' AND (rel_' . $this->_params['type'] . $cpt . '.id_rubrique=rubriques.id_rubrique)';
	        			break;
	        		case 'syndic':
	        			$queryWhereTmp .=   ' AND (rel_' . $this->_params['type'] . $cpt . '.id_syndic=syndic.id_syndic)';
	        			break;
	        	}
	        	
	        	$queryWhere[] = $queryWhereTmp;
	        	//$queryWhere[] =   'rel_' . $this->_params['type'] . $cpt . '.id_mot IN (' . join(',', $motAffecteIds) . ')';
	        }
		}
        else {
        	$queryFrom[] = $this->_params['table_relation'].'1';
        	$queryWhere[] = 'rel_' . $this->_params['type'] . '1.id_mot IN (-1)';
		}
        
        if(ereg("<!spipPERSONNALISATIONFROMspip!>", $query)) {
	        $query = ereg_replace("<!spipPERSONNALISATIONFROMspip!>", join(', ', $queryFrom), $query);
        }
        
		if(ereg("<!spipPERSONNALISATIONWHEREspip!>", $query)) {
	        $query = ereg_replace("<!spipPERSONNALISATIONWHEREspip!>", ' ( '.join(' AND ', $queryWhere) .' ) ', $query);
        }
        
        return($query);
    }
    
}
?>