<?php
require_once dirname(__FILE__)."/Filter.php";
require_once dirname(__FILE__)."/../../../sevenseas/ResultBuilder.php";
require_once dirname(__FILE__)."/../../../sevenseas/SearchEngine.php";
/*
require_once dirname(__FILE__)."/../../../sevenseas/SearchResult.php";
require_once dirname(__FILE__)."/../../../sevenseas/SearchResults.php";
*/

class FunctionSevenseasFilter extends Filter {

    var $_points = array();

    function queryFilter($query) {
        $queryWhere = array();
        if (lire_meta('activer_recherche_document') == 'oui') {
            $resultBuilder = new ResultBuilder();
            $searchEngine = &SearchEngine::factory(lire_meta("recherche_document_type"));
            if (PEAR::isError($searchEngine)) {
                die($searchEngine->getMessage());
            }
            $searchEngine->setResultBuilder($resultBuilder);

            $queryParams = array();
        
            $queryParams["textquery"] = $this->_params['q'];
        
            $results = &$searchEngine->search($queryParams);
            if (PEAR::isError($result)) {
                die($result->getMessage());
            } else {
                if(is_array($results->results)) {
                    while (list(,$myResult) = each($results->results)) {
                        $filename = trim($this->_transformPath($myResult->filename));
                        $this->_points[$filename] = $myResult->pertinence;
                        $queryWhere[] = 'documents.fichier LIKE \'' . $filename . '\'';
                    }
                }
                else {
                    $queryWhere[] = '1=2';
                }
            }
            
            if(ereg("<!spipSEVENSEASspip!>", $query)) {
                    $query = ereg_replace("<!spipSEVENSEASspip!>",' ( ' . join(' OR ', $queryWhere) . ' ) ', $query);
            }
        }
        else {
        if(ereg("<!spipSEVENSEASspip!>", $query)) {
                    $query = ereg_replace("<!spipSEVENSEASspip!>", '1=2', $query);
            }
        }
        
        return($query);
    }
    
    function rowsFilter($rows) {
        
        reset($rows);
        
        while(list(, $row) = each($rows)) {
            $row['points'] = $this->_points[$row['fichier']];
            $this->_rows[] = $row;
        }
        return($this->_rows);
    
    }
    
    function _transformPath($string) {
        $data_array = explode("/",$string);
        //var_dump($data_array);
        //$data_array = array_reverse($data_array);
        return $data_array[count($data_array)-3] .'/'. $data_array[count($data_array)-2] .'/'. $data_array[count($data_array)-1];
    }
    
}
?>