<?php
// +----------------------------------------------------------------------
// | PHP Source                                                           
// +----------------------------------------------------------------------
// |
// | Copyright: See COPYING file that comes with this distribution
// +----------------------------------------------------------------------
//

class Registry
{
    // {{{ constructor

    /**
     * Registry constructor. We don't need a formal "factory" method for now, let's keep it simple.
     *
     * @access public
     */

    function Registry() {
    }

    // }}}
	
    /**
    * Returns true if this instance of spip-agora is active (i.e. not embedded).
    * For explication of "embedded" concept of spip-agora, please check 
    * http://spip-agora.clever-age.org soon.
    */
    function instanceActive() {
        return true;
    }
    
    
    /**
    * A wrapper around normal, "header" PHP function. Sends the given header to the browser
    * in case of "active" agora instance or does nothing if the instance is "Embedded" (and should
    * therefore just shut up)
    */
    function header($header)
    {
        if (Registry::instanceActive())
            header($header);
    }
    
    /**
    * Small, static, but yet very useful debuging functions
    */
    function pre_var_dump(&$object)
    {
        echo "<pre>";
        var_dump($object);
        echo "</pre>";
    }
    
    function pre_var_dump_die(&$object)
    {
        Registry::pre_var_dump($object);
        die();
    }
    
}

?>
